## ros-humble-robot-controllers-interface 0.9.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(robot_controllers_interface)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(robot_controllers_msgs REQUIRED)
find_package(tf2_ros)

include_directories(
  include
)

add_library(robot_controllers_interface SHARED
  src/controller_loader.cpp
  src/controller_manager.cpp
)
ament_target_dependencies(robot_controllers_interface
  pluginlib
  rclcpp
  robot_controllers_msgs
  tf2_ros
)
target_compile_definitions(robot_controllers_interface PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS robot_controllers_interface
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/robot_controllers_interface
)

install(
  PROGRAMS
    scripts/get_controller_state.py
    scripts/start_controller.py
    scripts/stop_controller.py
  DESTINATION
    lib/${PROJECT_NAME}
)

if(BUILD_TESTING)
  find_package(ament_cmake_cpplint)
  ament_cpplint(FILTERS "-whitespace/braces" "-whitespace/newline")
endif()

ament_export_include_directories(include)
ament_export_libraries(robot_controllers_interface)
ament_export_dependencies(
  pluginlib
  rclcpp
  robot_controllers_msgs
  tf2_ros
)
ament_package()

=== debian/changelog ===
ros-humble-robot-controllers-interface (0.9.3-1bookworm) bookworm; urgency=high

  * Fix tf node spam (#80 <https://github.com/mikeferguson/robot_controllers/issues/80>)
    Stop the tf listener from creating its own node by passing a reference to the parent node.
    The parallelism is untouched as tf uses a callback group for the tf topics that is spon its own executor instance.
    This lowers the overhead from too many nodes and reduces spam in visualizations such as the rqt node graph.
  * Contributors: Florian Vahl

 -- Russell Toris <rtoris@fetchrobotics.com>  Sat, 20 Aug 2022 16:00:00 -0000

ros-humble-robot-controllers-interface (0.9.2-1bookworm) bookworm; urgency=high

  * fix a bug in the older constructor (#78 <https://github.com/mikeferguson/robot_controllers/issues/78>)
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Mon, 20 Jun 2022 16:00:00 -0000

ros-humble-robot-controllers-interface (0.9.1-1bookworm) bookworm; urgency=high

  * move transform listener to manager (#77 <https://github.com/fetchrobotics/robot_controllers/issues/77>)
    each transform listener incurs an extra DDS node, which can
    have a significant effect in a large system. this change
    allows our robot driverrs to have a single shared transform
    listener across all controllers (and even the whole node,
    since the buffer can be passed in with the new constructor)
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Sun, 19 Jun 2022 16:00:00 -0000

ros-humble-robot-controllers-interface (0.9.0-1bookworm) bookworm; urgency=high

  * update logging messages for galactic and later (#75 <https://github.com/fetchrobotics/robot_controllers/issues/75>)
    https://docs.ros.org/en/humble/Releases/Release-Galactic-Geochelone.html#change-in-rclcpp-s-logging-macros
    also add a few build cleanups, fails on humble otherwise
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Tue, 07 Jun 2022 16:00:00 -0000

ros-humble-robot-controllers-interface (0.8.1-1bookworm) bookworm; urgency=high

  * add Fergs as maintainer (#65 <https://github.com/fetchrobotics/robot_controllers/issues/65>)
  * additional boost disabling (#64 <https://github.com/fetchrobotics/robot_controllers/issues/64>)
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Tue, 01 Dec 2020 16:00:00 -0000

ros-humble-robot-controllers-interface (0.8.0-1bookworm) bookworm; urgency=high

  * Add initial support for ROS2
  * implement getJointNames/getControllerNames (#51 <https://github.com/fetchrobotics/robot_controllers/issues/51>)
    this was discussed in #39 <https://github.com/fetchrobotics/robot_controllers/issues/39>
  * Merge pull request #47 <https://github.com/fetchrobotics/robot_controllers/issues/47> from mikeferguson/ros2
  * improve logging
  * switch to service interface
  * gravity compensation controller working in ros2
  * Various bug and API fixes
  * Added gyro interface to robot controllers (#43 <https://github.com/fetchrobotics/robot_controllers/issues/43>)
  * Updates maintainers
  * Contributors: Alex Moriarty, Carl Saldanha, Michael Ferguson, Russell Toris

 -- Russell Toris <rtoris@fetchrobotics.com>  Tue, 24 Nov 2020 16:00:00 -0000

ros-humble-robot-controllers-interface (0.6.0-1bookworm) bookworm; urgency=high

  * updates ownership
  * Contributors: Russell Toris

 -- Russell Toris <rtoris@fetchrobotics.com>  Tue, 10 Jul 2018 16:00:00 -0000

ros-humble-robot-controllers-interface (0.5.3-1bookworm) bookworm; urgency=high

  * add error message when pluginlib fails
  * fix cmake warnings on kinetic (#28 <https://github.com/fetchrobotics/robot_controllers/issues/28>)
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Sat, 10 Jun 2017 16:00:00 -0000

ros-humble-robot-controllers-interface (0.5.2-1bookworm) bookworm; urgency=high



 -- Russell Toris <rtoris@fetchrobotics.com>  Sun, 17 Jul 2016 16:00:00 -0000

ros-humble-robot-controllers-interface (0.5.1-1bookworm) bookworm; urgency=high

  * Dynamically load controllers (#23 <https://github.com/fetchrobotics/robot_controllers/issues/23>)
    * When requested controller not in default list, check parameter server for controller
    * Controller loader catches pluginlib exception when trying to load bad controller
  * Return controller states even if update fails
  * Contributors: Michael Ferguson, Sarah Elliott

 -- Russell Toris <rtoris@fetchrobotics.com>  Sun, 17 Jul 2016 16:00:00 -0000

ros-humble-robot-controllers-interface (0.5.0-1bookworm) bookworm; urgency=high



 -- Russell Toris <rtoris@fetchrobotics.com>  Sat, 20 Feb 2016 16:00:00 -0000

ros-humble-robot-controllers-interface (0.4.3-1bookworm) bookworm; urgency=high

  * add mainpage to doxygen
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Fri, 04 Dec 2015 16:00:00 -0000

ros-humble-robot-controllers-interface (0.4.2-1bookworm) bookworm; urgency=high

  * add -Wall to interface package
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Wed, 21 Oct 2015 16:00:00 -0000

ros-humble-robot-controllers-interface (0.4.1-1bookworm) bookworm; urgency=high



 -- Russell Toris <rtoris@fetchrobotics.com>  Thu, 11 Jun 2015 16:00:00 -0000

ros-humble-robot-controllers-interface (0.4.0-1bookworm) bookworm; urgency=high



 -- Russell Toris <rtoris@fetchrobotics.com>  Fri, 22 May 2015 16:00:00 -0000

ros-humble-robot-controllers-interface (0.3.4-1bookworm) bookworm; urgency=high

  * add ability to reset controllers
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Thu, 21 May 2015 16:00:00 -0000

ros-humble-robot-controllers-interface (0.3.3-1bookworm) bookworm; urgency=high



 -- Russell Toris <rtoris@fetchrobotics.com>  Sat, 02 May 2015 16:00:00 -0000

ros-humble-robot-controllers-interface (0.3.2-1bookworm) bookworm; urgency=high

  * install scripts


=== debian/control ===
Source: ros-humble-robot-controllers-interface
Section: misc
Priority: optional
Maintainer: Russell Toris <rtoris@fetchrobotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-ament-cmake-cpplint <!nocheck>, ros-humble-pluginlib, ros-humble-rclcpp, ros-humble-rclcpp-action, ros-humble-robot-controllers-msgs, ros-humble-tf2-ros, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-robot-controllers-interface
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-pluginlib, ros-humble-rclcpp, ros-humble-rclcpp-action, ros-humble-robot-controllers-msgs, ros-humble-tf2-ros, ros-humble-ros-workspace
Description: Generic framework for robot controls.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-robot-controllers-interface//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-robot-controllers-interface//opt/ros/humble/opt/robot_controllers_interface/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
